/*
 * simple_ca_mc_protocol.h
 *
 *  Created on: 23 Aug 2010
 *      Author: jmacdona
 */

#ifndef SIMPLE_CA_MC_PROTOCOL_H_
#define SIMPLE_CA_MC_PROTOCOL_H_
#include "simulation/mc_protocol_interface.h"
#include <limits>

namespace PRODART {
namespace POSE {
namespace SIM {
namespace CA {


class simple_ca_mc_protocol;


typedef boost::shared_ptr<simple_ca_mc_protocol> simple_ca_mc_protocol_shared_ptr;

mc_protocol_interface_shared_ptr new_simple_ca_mc_protocol(unsigned long steps, double _beta, MTRand::MTRand_shared_ptr mt_ptr);

class simple_ca_mc_protocol : public mc_protocol_interface {


	friend mc_protocol_interface_shared_ptr new_simple_ca_mc_protocol(unsigned long steps, double _beta, MTRand::MTRand_shared_ptr mt_ptr);

private:


protected:


	simple_ca_mc_protocol(unsigned long steps, double _beta, MTRand::MTRand_shared_ptr mt_ptr) : mc_protocol_interface(steps, _beta, mt_ptr){
		/*
		this->steps_to_run = steps;
		this->beta = _beta;
		*/
	}

public:

	/*
	bool stage_initialise(mc_state& state,
			const PRODART::POSE::pose_shared_ptr protein,
			PRODART::POSE::META::pose_meta_shared_ptr meta_data,
			PRODART::POSE::POTENTIALS::potentials_container_shared_ptr potentials,
			PRODART::POSE::MOVERS::mover_shared_ptr movers);
	bool stage_continue(mc_state& state,
			const PRODART::POSE::pose_shared_ptr protein,
			PRODART::POSE::META::pose_meta_shared_ptr meta_data,
			PRODART::POSE::POTENTIALS::potentials_container_shared_ptr potentials,
			PRODART::POSE::MOVERS::mover_shared_ptr movers);
	bool stage_move(mc_state& state,
			const PRODART::POSE::pose_shared_ptr protein,
			PRODART::POSE::META::pose_meta_shared_ptr meta_data,
			PRODART::POSE::POTENTIALS::potentials_container_shared_ptr potentials,
			PRODART::POSE::MOVERS::mover_shared_ptr movers);
	bool stage_accept_test(mc_state& state,
			const PRODART::POSE::pose_shared_ptr protein,
			PRODART::POSE::META::pose_meta_shared_ptr meta_data,
			PRODART::POSE::POTENTIALS::potentials_container_shared_ptr potentials,
			PRODART::POSE::MOVERS::mover_shared_ptr movers);
	bool stage_accepted(mc_state& state,
			const PRODART::POSE::pose_shared_ptr protein,
			PRODART::POSE::META::pose_meta_shared_ptr meta_data,
			PRODART::POSE::POTENTIALS::potentials_container_shared_ptr potentials,
			PRODART::POSE::MOVERS::mover_shared_ptr movers);
	bool stage_rejected(mc_state& state,
			const PRODART::POSE::pose_shared_ptr protein,
			PRODART::POSE::META::pose_meta_shared_ptr meta_data,
			PRODART::POSE::POTENTIALS::potentials_container_shared_ptr potentials,
			PRODART::POSE::MOVERS::mover_shared_ptr movers);
	bool stage_finish(mc_state& state,
			const PRODART::POSE::pose_shared_ptr protein,
			PRODART::POSE::META::pose_meta_shared_ptr meta_data,
			PRODART::POSE::POTENTIALS::potentials_container_shared_ptr potentials,
			PRODART::POSE::MOVERS::mover_shared_ptr movers);
	 */


};




/*
 * INLINED functions
 */


/*
inline bool simple_ca_mc_protocol::stage_initialise(mc_state& state,
		const PRODART::POSE::pose_shared_ptr protein,
		PRODART::POSE::META::pose_meta_shared_ptr meta_data,
		PRODART::POSE::POTENTIALS::potentials_container_shared_ptr potentials,
		PRODART::POSE::MOVERS::mover_shared_ptr movers){


	protein->backup_coords();
	state.beta = this->beta;
	state.step_num = 0;
	state.was_big_move = false;
	state.stop = false;
	state.tries = 0;
	meta_data->set_update_pair_lists_flag();
	meta_data->recalc_pair_lists_dists();
	this->energy_map = potentials->get_default_energies_map();
	state.energy = potentials->get_energy(protein, meta_data, energy_map);
	state.prev_acc_energy = state.energy;

	return true;

}
inline bool simple_ca_mc_protocol::stage_continue(mc_state& state,
		const PRODART::POSE::pose_shared_ptr protein,
		PRODART::POSE::META::pose_meta_shared_ptr meta_data,
		PRODART::POSE::POTENTIALS::potentials_container_shared_ptr potentials,
		PRODART::POSE::MOVERS::mover_shared_ptr movers){

}
inline bool simple_ca_mc_protocol::stage_move(mc_state& state,
		const PRODART::POSE::pose_shared_ptr protein,
		PRODART::POSE::META::pose_meta_shared_ptr meta_data,
		PRODART::POSE::POTENTIALS::potentials_container_shared_ptr potentials,
		PRODART::POSE::MOVERS::mover_shared_ptr movers){

}
inline bool simple_ca_mc_protocol::stage_accept_test(mc_state& state,
		const PRODART::POSE::pose_shared_ptr protein,
		PRODART::POSE::META::pose_meta_shared_ptr meta_data,
		PRODART::POSE::POTENTIALS::potentials_container_shared_ptr potentials,
		PRODART::POSE::MOVERS::mover_shared_ptr movers){

}
inline bool simple_ca_mc_protocol::stage_accepted(mc_state& state,
		const PRODART::POSE::pose_shared_ptr protein,
		PRODART::POSE::META::pose_meta_shared_ptr meta_data,
		PRODART::POSE::POTENTIALS::potentials_container_shared_ptr potentials,
		PRODART::POSE::MOVERS::mover_shared_ptr movers){

}
inline bool simple_ca_mc_protocol::stage_rejected(mc_state& state,
		const PRODART::POSE::pose_shared_ptr protein,
		PRODART::POSE::META::pose_meta_shared_ptr meta_data,
		PRODART::POSE::POTENTIALS::potentials_container_shared_ptr potentials,
		PRODART::POSE::MOVERS::mover_shared_ptr movers){

}
inline bool simple_ca_mc_protocol::stage_finish(mc_state& state,
		const PRODART::POSE::pose_shared_ptr protein,
		PRODART::POSE::META::pose_meta_shared_ptr meta_data,
		PRODART::POSE::POTENTIALS::potentials_container_shared_ptr potentials,
		PRODART::POSE::MOVERS::mover_shared_ptr movers){

}
*/


}
}
}
}

#endif /* SIMPLE_CA_MC_PROTOCOL_H_ */
